//
// Institut fr Betriebssysteme und Rechnerverbund
// bungen zur Vorlesung "Verteilte Systeme", WS 02/03 
// http://www.ibr.cs.tu-bs.de/lehre/ws0203/vs/
// 
// Dozent: Prof. Dr. Stefan Fischer <fischer@ibr.cs.tu-bs.de>
// bungsleiter: Frank Strau <strauss@ibr.cs.tu-bs.de>
//
// Aufgabe 5.1 - CORBA mittels Java
//
// Der Client knnte so aussehen...
//
//   Usage: javac DocClient.java
//          java DocClient -ORBInitialHost hansa -ORBInitialPort 9000 test.html
//

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

import DocService.*;


public class DocClient 
{
    public static void main(String args[])
    {
        try {
            
            // Create and initialize the ORB
            ORB orb = ORB.init(args, null);
            
            // Get the root naming context
            org.omg.CORBA.Object nsobj =
                orb.resolve_initial_references("NameService");
            NamingContext context = NamingContextHelper.narrow(nsobj);
            
            // Resolve the object reference in naming
            NameComponent component = new NameComponent("DocServer", "");
            NameComponent path[] = {component};
            Doc doc = DocHelper.narrow(context.resolve(path));
            
            // Call the Hello server object and print results
            String document = doc.getURL(args[args.length-1]);
            System.out.println(document);
            
        } catch(Exception e) {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }
    }
}
