//
// Institut fr Betriebssysteme und Rechnerverbund
// bungen zur Vorlesung "Verteilte Systeme", WS 02/03 
// http://www.ibr.cs.tu-bs.de/lehre/ws0203/vs/
// 
// Dozent: Prof. Dr. Stefan Fischer <fischer@ibr.cs.tu-bs.de>
// bungsleiter: Frank Strau <strauss@ibr.cs.tu-bs.de>
//
// Aufgabe 4.1 - TCP Client/Server mittels Java
//
// Der Server knnte so aussehen...
//
//   Usage: javac TCPServer.java && java TCPServer
//

import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.InputStreamReader;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class TCPServer {

    public static void main (String args[]) {
        try {
            ServerSocket listenSocket = new ServerSocket(8000);
            while (true) {
                Socket socket = listenSocket.accept();
                Connection conn = new Connection(socket);
            }
        } catch(Exception e) {
            System.out.println(e);
        }
    }
}

class Connection extends Thread {

    BufferedReader in;
    PrintWriter out;
    Socket socket;

    public Connection (Socket clientSocket) {
        try {
            socket = clientSocket;
            in = new BufferedReader(
                 new InputStreamReader(socket.getInputStream()));
            out = new PrintWriter(socket.getOutputStream());
            this.start();
            System.out.println("Spawned Connection.");
        } catch (Exception e) {
            System.out.println(e);
        }
    }
    
    public void run() {
        try {
            char buf[] = new char[32768];
            int rc;
            String response;
            String request = in.readLine();
            System.out.println("Received Request: " + request);

            StringTokenizer st = new StringTokenizer(request);
            String method = st.nextToken();
            String uri = st.nextToken();

            try {
                st = new StringTokenizer(uri, "/");
                String basename = null;
                while (st.hasMoreTokens()) { basename = st.nextToken(); }
                FileReader file = new FileReader(basename);
                response = "HTTP/1.0 200 OK";
                out.println(response);
                out.println();
                do {
                    rc = file.read(buf);
                    if (rc > 0) {
                        out.write(buf);
                    }
                } while (rc >= 0);
                file.close();
            } catch (FileNotFoundException e) {
                response = "HTTP/1.0 404 Not Found";
                out.println(response);
                out.println();
            }

            out.flush();
            System.out.println("Sent Response: " + response);

            socket.close();
            System.out.println("Closed Connection.");
        } catch (Exception e) {
            System.out.println(e);
        }
    }
}
